//--------------------------------------------------------------------------------
//  RGBA/BGRA Format Sub Routines
//    Copyright  (C)  2005  kei mesuda  
//    (http://www.yomogi.sakura.ne.jp/~si)
//--------------------------------------------------------------------------------

#ifndef _CORE_RGBA_INCLUDED
#define _CORE_RGBA_INCLUDED

#ifndef RGBtoGRAY
#define RGBtoGRAY(r, g, b)    ((unsigned char)(((r)*77 + (g)*150 + (b)*29)>>8))
#endif

#pragma message ("<< CORE_MESSAGE >>  include RGBA.h")


//--------------------------------------------------------------------------------
// \̒` 
//--------------------------------------------------------------------------------

// RGBA f[^\
//--------------------------------------------------
typedef struct {
  char achIdentifier[4];        // "rgba"/"bgra" rbgz̒ʂDǂ
  unsigned short wWidth;        // WORD ^ȗŔCwb_ 8byte ̕
  unsigned short wHeight;       // ƂLǂȂƎv
  union {
    unsigned char abyData[1];   // pixel data {; BYTE  ANZX
    unsigned long adwData[1];   //                  DWORD ANZX
  };
} RGBA_DATA;



// ׂ摜tH[}bg ARGB
// "ƂĂ͂"ihttp://www.emit.jp/jq؁D
//--------------------------------------------------
typedef struct {
  union {
    unsigned char abyIdentifier[4]; // "BGRA"
    unsigned long dwIdentifier;     // 0x41524742(little endian)
  };
  unsigned long dwPixelFormat;      // 0x08080808(32bitColor) or 0x10101010(64bitColor)
  unsigned long dwWidth;
  unsigned long dwHeight;
} ArgbHeader;  



// Bitmap Info Header 
//--------------------------------------------------
typedef struct {
  unsigned long   biSize; 
  long            biWidth; 
  long            biHeight; 
  unsigned short  biPlanes; 
  unsigned short  biBitCount; 
  unsigned long   biCompression; 
  unsigned long   biSizeImage; 
  long            biXPelsPerMeter; 
  long            biYPelsPerMeter; 
  unsigned long   biClrUsed; 
  unsigned long   biClrImportant; 
} BIH; 

// ŒBitmap ̂ݎ擾DFile Pointer ́Cf[^擪܂ŐiށDiKj
bool ReadBitmapHeader(FILE* pFile, int* pWidth, int* pHeight, int* pBits, unsigned char* abyColorTable);





//--------------------------------------------------------------------------------
// ֐ 
//--------------------------------------------------------------------------------

// Ǘ 
//--------------------------------------------------

// ̈m
RGBA_DATA* CreateRGBAData(const int width, const int height, bool bRGBA);

// ̈/NULL
void DeleteRGBAData(RGBA_DATA* &pRGBA);



// Q
//--------------------------------------------------

// TCYvZ
int GetRGBADataSize(const RGBA_DATA* pRGBA);

// `f (K)
bool IsRGBA(const RGBA_DATA* pRGBA);



// 
//--------------------------------------------------

// ϊD"RGBA"<->"BGRA"
void ConvertRGBABits(RGBA_DATA* pRGBA, bool bRGBA);

// Ǎ (t@C̃tH[}bgɊ֌WbRGBAŎw肵`œǂ݂)
RGBA_DATA* LoadRGBAData(const char* strFileName, bool bRGBA);

// ۑ
bool SaveRGBAData(const RGBA_DATA* pRGBA, const char* strFileName);



// 
//--------------------------------------------------

// Bitmap Data ǂݍ݁iF}bvǂݍ݁CAt@255j 
RGBA_DATA* CompRGBAData(const char* strFileName, bool bRGBA);

// Bitmap Data ǂݍ݁iAt@}bvǂݍ݁CF͎wj
RGBA_DATA* CompRGBAData(unsigned char *abyColor, const char* strAlphaFileName, bool bRGBA);

// Bitmap Data ǂݍ݁iߐFwj 
RGBA_DATA* CompRGBAData(const char* strFileName, unsigned char *abyColor, bool bRGBA);

// Bitmap Data ǂݍ݁iF/At@}bv̓ǂݍ݁j
RGBA_DATA* CompRGBAData(const char* strFileName, const char* strAlphaFileName, bool bRGBA);

#endif //_CORE_RGBA_INCLUDED
