//--------------------------------------------------------------------------------
//  CSDLCore Thread Class
//    Copyright  (C)  2006  kei mesuda  
//    (http://www.yomogi.sakura.ne.jp/~si)
//--------------------------------------------------------------------------------
// class IThread
//   Thread ̊{NXD
//   z֐ Init()/Run()/Draw()/Exit()/InitScene()/ExitScene() I[o[ChāC
//   SDLCore::AddThread() Ń|C^o^ƁC
//   MainLoop Ăяo悤ɂȂD
//--------------------------------------------------------------------------------
class IThread
{
//--------------------------------------------------
//  thNX
//--------------------------------------------------
friend class CSDLThreadManager;
//--------------------------------------------------
//  oϐ
//--------------------------------------------------
private:
    IThread*    m_pNextChainedThread;   // oXg\
    IThread*    m_pPrevChainedThread;
    bool        m_bIsAlive;             // XbhOn/Off

//--------------------------------------------------
//  RXgN^
//--------------------------------------------------
public:
	// RXgN^
    IThread()
    {
        m_pNextChainedThread = NULL;
        m_pPrevChainedThread = NULL;
        m_bIsAlive = true;
    }

    // RXgN^iXbhOn/Offwj
    IThread(bool bAlive)
    {
        m_pNextChainedThread = NULL;
        m_pPrevChainedThread = NULL;
        m_bIsAlive = bAlive;
    }

//--------------------------------------------------
//  Xbh
//--------------------------------------------------
public:
    // Xbh̐ݒ
    inline void Alive(bool bAlive)
    {
        m_bIsAlive = bAlive;
    }

    // Xbh̐Q
    inline bool IsAlive()
    {
        return m_bIsAlive;
    }

//--------------------------------------------------
//  z֐
//--------------------------------------------------
public:
    virtual bool Init(){return true;}
    virtual bool Run(){return true;}
    virtual bool Draw(){return true;}
    virtual bool Exit(){return true;}
	virtual bool InitScene(){return true;}
	virtual bool ExitScene(){return true;}
};





//--------------------------------------------------------------------------------
// class CSDLThreadManager
//    IThread XgƂĕێCsD
//   CSDLCore oϐƂĎ̂ĂD
//--------------------------------------------------------------------------------
class CSDLThreadManager : public IThread
{
//--------------------------------------------------
//  oϐ
//--------------------------------------------------
private:
    // XbhXg̍ŏƍŌ
    IThread*    m_pFirstThread;
    IThread*    m_pLastThread;

	// V[Ǘ
    int         m_iSceneIndex;          // ݂̃V[ԍ
    int         m_iNextSceneIndex;      // t[Ő؂ւV[ԍ
    bool        m_bSceneChanged;        // t[ŃV[؂ւ邩H

//--------------------------------------------------
//  RXgN^
//--------------------------------------------------
public:
    CSDLThreadManager()
    {
        m_pFirstThread = NULL;
        m_pLastThread = NULL;
        m_iSceneIndex     = 0;
        m_iNextSceneIndex = 0;
        m_bSceneChanged   = false;
    }

//--------------------------------------------------
//  Xbh
//--------------------------------------------------
public:
    // sXgɃXbhǉ
    void AddThread(IThread* pThread)
    {
        if (m_pFirstThread == NULL) {
            m_pLastThread = m_pFirstThread = pThread;
        } else {
            InsertThreadAfter(m_pLastThread, pThread);
        }
    }

    // ptrInsertAfter ̌ newptr ǉCptrInsertAfter == NULL Ȃ擪ɒǉ
    void InsertThreadAfter(IThread* ptrInsertAfter, IThread* newptr)
    {
        if (ptrInsertAfter == NULL) {
            newptr->m_pNextChainedThread = m_pFirstThread;
            newptr->m_pPrevChainedThread = NULL;
            m_pFirstThread = newptr;
        } else {
            newptr->m_pNextChainedThread = ptrInsertAfter->m_pNextChainedThread;
            newptr->m_pPrevChainedThread = ptrInsertAfter;
            if (ptrInsertAfter->m_pNextChainedThread != NULL) {
                ptrInsertAfter->m_pNextChainedThread->m_pPrevChainedThread = newptr;
            } else {
                m_pLastThread = newptr;
            }
            ptrInsertAfter->m_pNextChainedThread = newptr;
        }
    }

//--------------------------------------------------
//  XbhQ
//--------------------------------------------------
private:
    IThread* GetFirstThread()
    {
        return m_pFirstThread;
    }

    IThread* GetLastThread()
    {
        return m_pLastThread;
    }

    IThread* GetNextThread(IThread* ptr)
    {
        return ptr->m_pNextChainedThread;
    }

    IThread* GetPrevThread(IThread* ptr)
    {
        return ptr->m_pPrevChainedThread;
    }

//--------------------------------------------------
//  V[
//--------------------------------------------------
public:
    // CSDLCore::ResetScene() Ă΂
    inline void ResetScene(int iSceneIndex)
    {
        m_iSceneIndex     = iSceneIndex;
        m_iNextSceneIndex = iSceneIndex;
        m_bSceneChanged   = false;
    }

    // CSDLCore::GetScene() Ă΂
    inline int GetScene()
    {
        return m_iSceneIndex;
    }

    // CSDLCore::ChangeScene() Ă΂
    inline void ChangeScene(int iNextSceneIndex)
    {
        m_iNextSceneIndex = iNextSceneIndex;
        m_bSceneChanged = true;
    }

    // MainLoop() CIThread::Run()̒OɌĂ΂
    inline bool RunScene()
    {
        if (m_bSceneChanged) {
            m_bSceneChanged = false;
        	if (!ExitScene()) return false;
            m_iSceneIndex = m_iNextSceneIndex;
            if (!InitScene()) return false;
        }
    	return true;
    }

//--------------------------------------------------
//  Xbhs
//--------------------------------------------------
public:
    // SqXbhInit()s
    bool Init()
    {
        for (IThread *ptr = GetFirstThread(); ptr != NULL; ptr = GetNextThread(ptr)) {
            if (!ptr->Init()) return false;
        }
        return true;
    }

    // ĂqXbhRun()s
    bool Run()
    {
        if (IsAlive()) {
            for (IThread *ptr = GetFirstThread(); ptr != NULL; ptr = GetNextThread(ptr)) {
                if (ptr->IsAlive()) {
                    if (!ptr->Run()) return false;
                }
            }
        }
        return true;
    }

    // ĂqXbhDraw()s
    bool Draw()
    {
        if (IsAlive()) {
            for (IThread *ptr = GetFirstThread(); ptr != NULL; ptr = GetNextThread(ptr)) {
                if (ptr->IsAlive()) {
                    if (!ptr->Draw()) return false;
                }
            }
        }
        return true;
    }

    // SqXbhExit()tŎs
    bool Exit()
    {
        for (IThread *ptr = GetLastThread(); ptr != NULL; ptr = GetPrevThread(ptr)) {
            if (!ptr->Exit()) return false;
        }
        return true;
    }

    // ĂqXbhInitScene()s
    bool InitScene()
    {
        if (IsAlive()) {
            for (IThread *ptr = GetFirstThread(); ptr != NULL; ptr = GetNextThread(ptr)) {
                if (ptr->IsAlive()) {
                    if (!ptr->InitScene()) return false;
                }
            }
        }
        return true;
    }

    // ĂqXbhExitScene()s
    bool ExitScene()
    {
        if (IsAlive()) {
            for (IThread *ptr = GetFirstThread(); ptr != NULL; ptr = GetNextThread(ptr)) {
                if (ptr->IsAlive()) {
                    if (!ptr->ExitScene()) return false;
                }
            }
        }
        return true;
    }
};

