//--------------------------------------------------------------------------------
//  Script Parser
//    Copyright  (C)  2005  kei mesuda  
//    (http://www.yomogi.sakura.ne.jp/~si)
//--------------------------------------------------------------------------------

#ifndef _CORE_SIMPLESCRIPT_INCLUDED
#define _CORE_SIMPLESCRIPT_INCLUDED

#include <vector> 
#include <string>
#pragma message ("<< CORE_MESSAGE >>  include CSimpleScript")

namespace Util {
class CSimpleScript
{
private:
    FILE*               m_pFile;                // File
    int                 m_iLineCount;           // Open()ĂCReadLine()ꂽ
    int                 m_idx;                  // obt@̃CfbNX
   
    std::string         m_strFileName;          // File Name
    std::string         m_strFileDirectory;     // File uĂfBNgpX
    
    std::string         m_strLine;              // sobt@
    std::vector<char>   m_achTokenPool;         // ؂og[Nu
    
    char                m_chSeparator;          // s
    std::string         m_strWhiteChar;         // 󔒕Q
    std::string         m_strTokenChar;         // TokenQ
 
private:
    bool  DivScriptToLine();                            // Script -> m_strLine ɕ 
    bool  SetTokenPool(const char* &ptr, int isize);    // m_achTokenPool  token u    

public:
    CSimpleScript();
    CSimpleScript(char* strFileName);
    ~CSimpleScript();

    // ݒ
    void    SetSeparator(char  chSpe);              // s̐ݒ 
    void    SetWhiteChar(char* ach);                // 󔒕Q̐ݒ 
    void    SetTokenChar(char* ach);                // TokenQ̐ݒ 

    // /
    bool    Open(char* strFileName);                // t@CJ
    void    Close();                                // t@C
    int     ReadLine();                             // Pśi͂ꂽg[NԂj
    
    // f[^Q 
    const char* m_strToken;                         // ݎQƂĂg[Ñ|C^ 

    const char* GetHeadToken();                     // ŏ̃g[N擾
    const char* GetNextToken();                     // g[N擾iReadLine(),ResetSequence() ́Cŏ̃g[N擾j 
    const char* GetToken(int idx);                  // CӃCfbNX̃g[N擾
    void        ResetSequence();                    // GetNextToken() ̏擾Zbg
    // GetNextToken + alpha
    const char* GetNextFloat(float* fv);            // atof(GetNextToken())
    const char* GetNextInt(int* iv);                // atoi(GetNextToken())
    const char* GetNextDWORD(unsigned long* dwv);   // strtoul(GetNextToken(), NULL, 16)
    const char* GetNextComp(char* strComp);         // (strcmp(GetNextToken(), strComp) == 0) ? strNextToken : NULL

    // t@CI[ɒB
    inline bool IsEOF() const
    {
        return (feof(m_pFile) != 0);
    }

    // t@C|C^Ԃ
    inline FILE* GetFile() const
    {
        return m_pFile;
    }

    // t@C̒uĂfBNgpXԂ
    inline const char* GetFileDir() const
    {
        return m_strFileDirectory.data();
    }

    // ݉͒̍sԍԂ
    inline int GetLineCounter() const
    {
        return m_iLineCount;
    }

    // ReadLine ʂ̂܂ܕԂ
    inline const char* GetLine() const
    {
        return m_strLine.data();
    }
};

} // namespace Util

#endif  // _CORE_SIMPLESCRIPT_INCLUDED

